# print, puts -> $stdout.print, $stdout.puts # $<ȂH
# mainARGV -> argv

=begin
def print ( str )
  $stdout.print str
end

def puts ( str )
  $stdout.puts str
end
=end

def main ( argv = [] )
  ti = Time::now
  print "\n-- #{NDIARY_VERSION} --\n\n"

  if RUBY_VERSION < REQUIRED_RUBY_VER then
    $stderr.puts "\n** error: this script require ruby #{REQUIRED_RUBY_VER} or later.\n"
    exit
  end

  # Load Configuration
  if /.+\.conf$/i =~ argv[0] or /\.ndiaryrc$/ =~ argv[0] then
    configfile = argv.shift
  else
    configfile = ENV['HOME'].to_s + File::Separator + ".ndiaryrc";
    unless File::readable? configfile then
      configfile = 'ndiary.conf'
    end
  end

  unless File::readable? configfile then
    $stderr.puts "\n** error: config file '#{configfile}' not found.\n"
    exit
  end
  
  config = Config::new
  config.load(configfile)
  config.setarray('TOPIC', 'FILTER')

  filter = Filter::new(config['FILTER'], config['USER_FILTER_DIRECTORY'])
  config['MONTH_PART_NAMES'] = [] unless config['MONTH_PART_NAMES'].kind_of?(Array)

  while argv[0].to_s[0,1] == "-" do
    opt = argv.shift
    opt.sub!(/^\-/, '')
    key, value = opt.split('=', 2)
    if value.nil? then
      config[key] = true
    else
      begin
        config[key] = eval(value.tosjis)
      rescue
        config[key] = value.tosjis
      end
    end
  end

  config.freeze

  monthPartNames = [''] * 32
  monthPartNames[1,0] = config['MONTH_PART_NAMES']
  monthPartNames = monthPartNames[0..31]

  pastDiary                     = PastDiary::new
  pastDiary.config              = config
  pastDiary.monthPartNames      = monthPartNames
  pastDiary.filter              = filter
  pastDiary.getDiaries


  if pastDiary.allDiaries.keys.nil? or pastDiary.allDiaries.keys.size < 1 then
    $stderr.puts "\n** error: no .diary file under #{pastDiary.logDirectory}.\n"
    exit(1)
  end

  if argv.size.zero? then
    pastDiary.targetMonth = pastDiary.allDiaries.keys.sort.reverse[0][0..5]
    pastDiary.makeHTML

    lastDiary                     = LastDiary::new
    lastDiary.config              = config
    lastDiary.monthPartNames      = monthPartNames
    lastDiary.getDiaries(pastDiary)
    lastDiary.filter              = filter
    lastDiary.makeHTML
    year = lastDiary.allDiaries.keys.sort.reverse[0][0..3]

  elsif argv[0] =~ /^(\d{6})$/ then
    pastDiary.targetMonth = $1
    pastDiary.makeHTML
    year = argv[0][0..3]

  elsif argv[0].downcase == 'all' then
    for month in pastDiary.months
      pastDiary.targetMonth = month
      pastDiary.makeHTML
    end

  else
    $stderr.puts "\n** Bad Parameter: '#{argv[0]}'\n"
    exit
  end

  # make topic list
  if !config['TOPIC'].nil? and config['TOPIC'].size > 0 then
    t = Topics::new
    t.topicDateFormat  = config['TOPIC_DATE_FORMAT']
    t.topicMonthFormat = config['TOPIC_MONTH_FORMAT']
    t.diary            = pastDiary
    config['TOPIC'].each{ |topic|
      filename, regexp, pattern, replace = topic.split(/\t/)
      t.skelton = filename
      t.regexp  = regexp  ? regexp  : ''
      t.pattern = pattern ? pattern : ''
      t.replace = replace ? replace : ''
      t.writeHTML(pastDiary.allDiaries.keys, true, year)
    }
  end

  puts "\nfinish. (#{Time::now - ti}sec.)"
end

